import java.io.*;
import java.util.*;

public class TestGen {

	PrintWriter out;
	Random rnd;
	int tNumber;

	class Test {
		int n, m, k;
		int[][] vol;
		int[] jury;
		int[] tc;

		void printTest() throws IOException {
			if (tNumber < 10)
				out = new PrintWriter("./0" + tNumber);
			else
				out = new PrintWriter("./" + tNumber);
			System.out.println(tNumber);
			tNumber++;
			out.println(n + " " + m + " " + k);
			for (int i = 0; i < n; i++) {
				out.println(vol[i][0] + 1 + " " + (vol[i][1] + 1));
			}
			if (m > 1) {
				for (int i = 0; i < m - 1; i++) {
					out.print(jury[i] + 1);
					if (i < m - 2)
						out.print(' ');
				}

			}
			out.println();
			if (k > 1) {
				for (int i = 0; i < k - 1; i++) {
					out.print(tc[i] + 1);
					if (i < k - 2)
						out.print(' ');
				}
			}
			out.println();
			out.close();
		}

		void genMin(int n, int id) throws IOException {
			if (id == 0)
				m = n + 1;
			else
				k = n + 1;
			for (int i = 0; i < n; i++) {
				vol[i][id] = i;
			}
			for (int i = 0; i < n; i++) {
				if (id == 0)
					jury[i] = n;
				else
					tc[i] = n;
			}
		}

		public void genRandomTree(int n, int ind, double prob) {
			if (prob >= 1)
				throw new AssertionError();
			ArrayList<Node> status = new ArrayList<>();
			for (int i = 0; i < n; i++) {
				status.add(new Node(-i - 1));
			}
			int tCount = 0;
			ArrayList<Node> newStatus = new ArrayList<TestGen.Test.Node>();
			Node current = null;
			while (status.size() > 1) {
				// System.err.println("st: " + status);
				for (int i = 0; i < status.size(); i++) {
					if (rnd.nextDouble() > Math.sqrt(prob)) {
						newStatus.add(status.get(i));
						current = null;
						continue;
					}
					if (current == null) {
						current = new Node(tCount);
						tCount++;
						newStatus.add(current);
					}
					if (status.get(i).id >= 0) {
						if (ind == 0)
							jury[status.get(i).id] = tCount - 1;
						else
							tc[status.get(i).id] = tCount - 1;
					} else {
						vol[-status.get(i).id - 1][ind] = tCount - 1;
					}
				}
				status = newStatus;
				newStatus = new ArrayList<TestGen.Test.Node>();
				current = null;
			}
			if (ind == 0)
				m = tCount;
			else
				k = tCount;
		}

		public void genKTree(int n, int k, int ind) {
			ArrayList<Integer> current = new ArrayList<Integer>();
			for (int i = 0; i < n; i++) {
				vol[i][ind] = i / k;
				if (current.size() == 0
						|| current.get(current.size() - 1) != i / k) {
					current.add(i / k);
				}
			}
			int tCount = current.size();
			while (current.size() > 1) {
				ArrayList<Integer> newCur = new ArrayList<Integer>();
				for (int j = 0; j < current.size(); j++) {
					if (ind == 0)
						jury[current.get(j)] = tCount + j / k;
					else
						tc[current.get(j)] = tCount + j / k;
					if (newCur.size() == 0
							|| newCur.get(newCur.size() - 1) != tCount + j / k)
						newCur.add(tCount + j / k);
				}
				tCount += newCur.size();
				current = newCur;
			}
			if (ind == 0)
				this.m = tCount;
			else
				this.k = tCount;
		}

		void genAll(int n, int m, int id) {
			for (int i = 0; i < n; i++) {
				vol[i][id] = 0;
			}
			if (id == 0)
				this.m = m;
			else
				this.k = m;
			for (int i = 0; i < m - 1; i++) {
				if (id == 0)
					jury[i] = i + 1;
				else
					tc[i] = i + 1;
			}
		}

		private void init(int n, int m, int k) {
			this.n = n;
			this.m = m;
			this.k = k;
			vol = new int[n][2];
			jury = new int[m];
			tc = new int[k];
			Arrays.fill(jury, -1);
			Arrays.fill(tc, -1);
			Arrays.fill(vol[0], -1);
			Arrays.fill(vol[1], -1);
		}

		class Node implements Comparable<Node> {
			int id;
			int min;

			Node(int id) {
				this.id = id;
				if (id < 0) {
					min = -id - 1;
				} else {
					min = id;
				}
			}

			@Override
			public int compareTo(Node o) {
				return Integer.compare(min, o.min);
			}

			@Override
			public String toString() {
				return "Node [id=" + id + ", min=" + min + "]";
			}
		}
	}

	public void solve() throws IOException {
		tNumber = 1;
		rnd = new Random(31);
		Test t = new Test();
		// small tests
		t.init(100, 100, 100);
		t.genAll(100, 100, 0);
		t.genAll(100, 100, 1);
		t.printTest();

		t.init(50, 100, 100);
		t.genAll(50, 100, 0);
		t.genAll(50, 1, 1);
		t.printTest();

		t.init(50, 100, 100);
		t.genAll(50, 1, 0);
		t.genAll(50, 1, 1);
		t.printTest();

		t.init(99, 100, 100);
		t.genMin(99, 0);
		t.genMin(99, 1);
		t.printTest();

		t.init(90, 100, 100);
		t.genKTree(90, 2, 0);
		t.genKTree(90, 3, 1);
		t.printTest();

		t.init(100, 100, 100);
		t.genRandomTree(100, 0, 0.3);
		t.genKTree(100, 3, 1);
		t.printTest();

		t.init(100, 100, 100);
		t.genKTree(100, 5, 0);
		t.genRandomTree(100, 1, 0.9);
		t.printTest();

		t.init(100, 100, 100);
		t.genKTree(100, 5, 0);
		t.genKTree(100, 7, 1);
		t.printTest();

		t.init(100, 100, 100);
		t.genKTree(100, 5, 0);
		t.genAll(100, 100, 1);
		t.printTest();

		t.init(99, 100, 100);
		t.genMin(99, 0);
		t.genKTree(99, 3, 1);
		t.printTest();

		t.init(100, 100, 100);
		t.genRandomTree(100, 0, 0.7);
		t.genRandomTree(100, 1, 0.6);
		t.printTest();

		t.init(100, 100, 100);
		t.genRandomTree(100, 0, 0.6);
		t.genRandomTree(100, 1, 0.5);
		t.printTest();

		t.init(90, 100, 100);
		t.genRandomTree(90, 0, 0.4);
		t.genRandomTree(90, 1, 0.6);
		t.printTest();

		t.init(100, 100, 100);
		t.genRandomTree(100, 0, 0.4);
		t.genRandomTree(100, 1, 0.4);
		t.printTest();

		t.init(100, 100, 100);
		t.genRandomTree(100, 0, 0.6);
		t.genRandomTree(100, 1, 0.6);
		t.printTest();

		// medium tests
		t.init(5000, 5000, 5000);
		t.genAll(5000, 5000, 0);
		t.genAll(5000, 5000, 1);
		t.printTest();

		t.init(4900, 5000, 5000);
		t.genAll(4900, 5000, 0);
		t.genAll(4900, 1, 1);
		t.printTest();

		t.init(4900, 5000, 5000);
		t.genAll(4900, 1, 0);
		t.genAll(4900, 1, 1);
		t.printTest();

		t.init(4900, 5000, 5000);
		t.genMin(4900, 0);
		t.genMin(4900, 1);
		t.printTest();

		t.init(4900, 5000, 5000);
		t.genKTree(4900, 2, 0);
		t.genKTree(4900, 3, 1);
		t.printTest();

		t.init(5000, 5000, 5000);
		t.genRandomTree(5000, 0, 0.3);
		t.genKTree(5000, 3, 1);
		t.printTest();

		t.init(5000, 5000, 5000);
		t.genKTree(5000, 5, 0);
		t.genRandomTree(5000, 1, 0.5);
		t.printTest();

		t.init(5000, 5000, 5000);
		t.genKTree(5000, 6, 0);
		t.genKTree(5000, 7, 1);
		t.printTest();

		t.init(4900, 5000, 5000);
		t.genKTree(4900, 2, 0);
		t.genAll(4900, 5000, 1);
		t.printTest();

		t.init(4900, 5000, 5000);
		t.genMin(4900, 0);
		t.genKTree(4900, 3, 1);
		t.printTest();

		t.init(4000, 5000, 5000);
		t.genRandomTree(4000, 0, 0.3);
		t.genRandomTree(4000, 1, 0.4);
		t.printTest();

		t.init(4000, 5000, 5000);
		t.genRandomTree(4000, 0, 0.5);
		t.genRandomTree(4000, 1, 0.25);
		t.printTest();

		t.init(4900, 5000, 5000);
		t.genRandomTree(4900, 0, 0.5);
		t.genRandomTree(4900, 1, 0.25);
		t.printTest();

		t.init(5000, 5000, 5000);
		t.genRandomTree(5000, 0, 0.4);
		t.genRandomTree(5000, 1, 0.6);
		t.printTest();

		t.init(5000, 5000, 5000);
		t.genRandomTree(5000, 0, 0.7);
		t.genRandomTree(5000, 1, 0.7);
		t.printTest();

		// large tests
		t.init(100000, 100000, 100000);
		t.genAll(100000, 100000, 0);
		t.genAll(100000, 100000, 1);
		t.printTest();

		t.init(99900, 100000, 100000);
		t.genAll(99900, 100000, 0);
		t.genAll(99900, 1, 1);
		t.printTest();

		t.init(99900, 100000, 100000);
		t.genAll(99900, 1, 0);
		t.genAll(99900, 1, 1);
		t.printTest();

		t.init(99900, 100000, 100000);
		t.genMin(99900, 0);
		t.genMin(99900, 1);
		t.printTest();

		t.init(95000, 100000, 100000);
		t.genKTree(95000, 2, 0);
		t.genKTree(95000, 3, 1);
		t.printTest();

		t.init(95000, 100000, 100000);
		t.genRandomTree(95000, 0, 0.8);
		t.genKTree(95000, 3, 1);
		t.printTest();

		t.init(100000, 100000, 100000);
		t.genKTree(100000, 5, 0);
		t.genRandomTree(100000, 1, 0.5);
		t.printTest();

		t.init(100000, 100000, 100000);
		t.genKTree(100000, 6, 0);
		t.genKTree(100000, 7, 1);
		t.printTest();

		t.init(99900, 100000, 100000);
		t.genKTree(99900, 2, 0);
		t.genAll(99900, 100000, 1);
		t.printTest();

		t.init(99900, 100000, 100000);
		t.genMin(99900, 0);
		t.genKTree(99900, 3, 1);
		t.printTest();

		t.init(99000, 100000, 100000);
		t.genRandomTree(99000, 0, 0.5);
		t.genRandomTree(99000, 1, 0.25);
		t.printTest();

		t.init(99000, 100000, 100000);
		t.genRandomTree(99000, 0, 0.25);
		t.genRandomTree(99000, 1, 0.5);
		t.printTest();

		t.init(99900, 100000, 100000);
		t.genRandomTree(99900, 0, 0.6);
		t.genRandomTree(99900, 1, 0.6);
		t.printTest();

		t.init(100000, 100000, 100000);
		t.genRandomTree(100000, 0, 0.4);
		t.genRandomTree(100000, 1, 0.3);
		t.printTest();

		t.init(99000, 100000, 100000);
		t.genRandomTree(99000, 0, 0.25);
		t.genAll(99000, 87654, 1);
		t.printTest();

		t.init(99000, 100000, 100000);
		t.genRandomTree(99000, 0, 0.3);
		t.genRandomTree(99000, 1, 0.3);
		t.printTest();

		t.init(99000, 100000, 100000);
		t.genMin(99000, 0);
		t.genRandomTree(99000, 1, 0.4);
		t.printTest();

		t.init(99900, 100000, 100000);
		t.genAll(99900, 98765, 0);
		t.genRandomTree(99900, 1, 0.8);
		t.printTest();

		t.init(100000, 100000, 100000);
		t.genRandomTree(100000, 0, 0.3);
		t.genRandomTree(100000, 1, 0.3);
		t.printTest();

		t.init(100000, 100000, 100000);
		t.genRandomTree(100000, 0, 0.5);
		t.genAll(100000, 98765, 1);
		t.printTest();

	}

	public void run() {
		try {

			solve();

		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public static void main(String[] args) {
		new TestGen().run();
	}
}
