import java.io.*;
import java.util.*;

public class volunteers_pk_n3 {

	void solve() throws IOException {
		int n = nextInt();
		int m = nextInt();
		int k = nextInt();
		boolean[][] juryCommand = new boolean[m][n];
		boolean[][] tcCommand = new boolean[k][n];
		for (int i = 0; i < n; i++) {
			int l = nextInt() - 1;
			juryCommand[l][i] = true;
			int r = nextInt() - 1;
			tcCommand[r][i] = true;
		}
		for (int j = 0; j < m - 1; j++) {
			int l = nextInt() - 1;
			update(juryCommand[l], juryCommand[j]);
		}
		for (int j = 0; j < k - 1; j++) {
			int r = nextInt() - 1;
			update(tcCommand[r], tcCommand[j]);
		}
		long sum = 0;
		for (int i = 0; i < m; i++) {
			for (int j = 0; j < k; j++) {
				boolean fl = false;
				for (int t = 0; t < n; t++) {
					if (juryCommand[i][t] && tcCommand[j][t])
						fl = true;
				}
				if (fl)
					sum++;
			}
		}
		out.println(sum);
	}

	void update(boolean[] a, boolean[] b) {
		for (int i = 0; i < a.length; i++) {
			a[i] |= b[i];
		}
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;

	void run() {
		try {
			// br = new BufferedReader(new InputStreamReader(System.in));
			// out = new PrintWriter(System.out);

			br = new BufferedReader(new FileReader(new File("volunteers.in")));
			out = new PrintWriter("volunteers.out");
			solve();

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public static void main(String[] args) {
		new volunteers_pk_n3().run();
	}

	String nextToken() throws IOException {
		while ((st == null) || !st.hasMoreTokens())
			st = new StringTokenizer(br.readLine());
		return st.nextToken();
	}

	int nextInt() throws NumberFormatException, IOException {
		return Integer.parseInt(nextToken());
	}

	double nextDouble() throws NumberFormatException, IOException {
		return Double.parseDouble(nextToken());
	}

	long nextLong() throws NumberFormatException, IOException {
		return Long.parseLong(nextToken());
	}
}
